<?php
namespace wbb\system\dashboard\box;
use wcf\data\shoutbox\ShoutboxEntryFactory;
use wcf\data\dashboard\box\DashboardBox;
use wcf\page\IPage;
use wcf\system\dashboard\box\AbstractContentDashboardBox;
use wcf\system\WCF;

/**
 * Shoutbox content dashboard
 * 
 * @author	Sonnenspeer
 * @copyright	2013 Sonnenspeer
 * @license	GNU Lesser General Public License <http://opensource.org/licenses/lgpl-license.php>
 * @package	de.sonnenspeer.shoutbox
 */
class ShoutboxContentDashboardBox extends AbstractContentDashboardBox {
	
    /**
     * shoutbox factory
     */
    public $factory = null;
	
	/**
	 * status
	 */
	public $status = null;
    
    /**
     * @see    wcf\system\dashboard\box\IDashboardBox::init()
     */
    public function init(DashboardBox $box, IPage $page) {
        parent::init($box, $page);
		
		$this->factory = new ShoutboxEntryFactory();
		$this->factory->init();
		
		// get status
		if (WCF::getUser()->userID) {
			$this->status = intval(WCF::getUser()->shoutboxBoxStatus);
		}
		else {
			if (($this->status = WCF::getSession()->getVar('shoutboxBoxStatus')) === null) {
				$this->status = 1;
			}
		}
		
		$this->fetched();
    }
    
    /**
     * @see    wcf\system\dashboard\box\AbstractContentDashboardBox::render()
     */
    protected function render() {		
		// assign variables
		WCF::getTPL()->assign(array(
			'smileys' => $this->factory->getSmileys(),
			'shoutboxEntries' => $this->factory->getEntries(),
			'shoutboxBoxStatus' => $this->status,
			'username' => WCF::getSession()->username
		));
		
		return WCF::getTPL()->fetch('dashboardBoxShoutbox', 'wbb');
    }
}